import { Provider, connect } from 'react-redux';
import { useEffect, useState } from 'react'
import { Header, Footer, MainImg, Links } from "./index"
import thunk from 'redux-thunk';
import { bindActionCreators } from 'redux';
import actionCatalogCard from './../reducers/reducerCat';




const Catalog = ({ state, categories = [], getData = () => console.log("no") }) => {
    useEffect(() => categories.length == 0 && getData(), []);
    //const [show, changeValue] = useState(false);

    return (
        <>
            <ul className="catalog">
                {categories.map(category =>
                    category.subCategories == null ?
                        <Links key={category._id} url={`/catalog/` + category._id} text={category.name}> </Links> :

                        <li>{category.name} {<ul className="catalog">{category.subCategories.map(subCategory =>
                            <Links key={subCategory._id} url={`/catalog/` + subCategory._id} text={subCategory.name}> </Links>)}</ul>}</li>

                )}
            </ul>
        </>
    )
}

const getCategories = state => {
    console.log("state", state)
    if (state.promiseRed.categories && state.promiseRed.categories.payload) {
        return state.promiseRed.categories.payload.data.CategoryFind
    }

    return [];
};
const mapStateToProps = state => ({
    state: state,
    categories: getCategories(state)
});

const mapDispatchToProps = dispatch => bindActionCreators({
    getData: actionCatalogCard
}, dispatch);


export default connect(mapStateToProps, mapDispatchToProps)(Catalog);